/********************************************************
*		mode 2 demo
*
*				by devoto
*
*   this is a quick demo to show the basics of background
*	rotation.  It also covers sprite rotation.  I tried to 
*	comment as I go.  If you have any questions find me on
*	#gbadev on efnet or email me at jason@agbdev.net or
*	just check my site www.agbdev.net/thePERNproject.com for
*	updates.
********************************************************/

// Gba.h has all the register definitions
#include "gba.h"     //from Eloist Wire cube Demo, defines the main GBA registers
#include "data.h"	 //all the external textures and such are declared here.
#include "keypad.h"  //All the keypad definitions thanks to nokturn
#include "sprite.h"
#include <math.h>

#define DMA3SAD		*(u32*)0x040000d4			//setups up all display variables.  read the official docs for more info
#define DMA3DAD		*(u32*)0x040000d8
#define DMA3CNT		*(u32*)0x040000dc

extern void S_Move(pSprite sp,u16 x, u16 y);
extern void S_Kill(pSprite sp);
extern void S_CopyToRam(pSprite sp);
extern void S_Animate(pSprite sp);
extern int S_Initialize(pSprite sp,  u16 x, u16 y,char shape, char type);
extern void S_Flip(pSprite sp, u8 fV, u8 fH);
extern void S_Rotate(pSprite sp, u16 angle);
extern void S_ChangeState(pSprite sp, u8 state);

//Some direction defines 

#define PI 3.14159
#define RADIAN(n) (((float)n)/(float)180*PI)

#define fixed s32  //fixed point numbers gotta love em.

typedef void (*fp)(); //this is a funcion pointer.  It is used to call a function that has 
				//been moved to RAM.  It is highly recomended that any code that you plan on 
				//exicuteing from ROM be thumb code.  If you have any functions that are 
				//highly speed critical do them with ARM and copy that function to ram.
u8 fMoved = 0;				
u8 eCount = 0;
u16 OAM[128*4];
int x_rotate = 120;  //this is the initial center x point of the rotation
int y_rotate = 80;	 //same for y	
int x_scroll = 128<<8;  //this is the scroll value.  It determines the center of
int y_scroll = 128<<8;	//of the maps(like BGxHOFS and BGxVOFS for text back
						//grounds.  if you just increment or decrement without
						//taking into account the angle of rotation you will not scroll
						//as you expect.

fixed zoom = 4<<8;      //this is the zoom value.  it is fixed point with 8 bits of fraction
						//the higher the number the further from the background you
						//get
s16 angle;				//this is the rotation angle

//memory offset of the palette mem and video
u16 *palette_mem = (u16*)0x5000000;//this is were palette data is stored. A 16 bit value
									//for the redgreenblue of each color.  256 entries
									//for the background followed by 256 for object data
u16* Video_BufferBack = (u16*)0x600A000;//this is for mode 4 and 5 which have a back buffer.
							
u16* Video_Memory = (u16*)0x6000000;//this is the area that map data will be stored in 
									//tile modes. and video mem in modes 3,4,5;
u32* RAM = (u32*)0x3000000;			//this is a pointer to the begining of RAM
									//used to copy functions to RAM for faster exicution
									//not used in this demo..Check out maze 7a to see how it works

u16* OAMmem = (u16*)0x7000000;		//OAM data starts here.  Room for 128 objects.  OAM data
									//can not be updated outside of a VBLANK unless you have 
									//update on HBLANK enabled.  This is controlled by a bit in
									//DSPCNT register

u32* OAMdata = (u32*)0x6010000;     //holds oam tile data actual sprite frames; in mode 3,4
									//or 5 there is only half the texture space and OAM data
									//starts at 0x6014000;

u16* ScreenData3 = (u16*)0x6008000; //this were the screen map goes.  It can be placed any 
									//ware on a 2k boundry in video ram.  Must be specified
									//by BG*CNT register.  By setting bits 8 - 12 you can specify
									//were screne data resides.  It is just a 5 bit number
									//were 0 = 0x6000000, 1 = 0x6000500 ...16 =0x6008000 ...
									//31 = 0x600f500.
u16* CharData3 = (u16*)0x6004000;   //this is were the actual tile data goes.  It is controled
									//by bits 2 and 3 of BG*CNT.  tile data can be placed on any 
									//16k boundry in video ram.You must ensure that the BG*CNT
									//register points to the corect memory location for character
									//data and screen data.  I do this by hand in this demo for 
									//the purpose of demonstration but I recomend you write a function
									//to handle this.  Learn it and forget it.  Sceen data consists
									//of a 16 bit number that has 9 bits for the tile and a few other
									//bits that controll horizontal and verticle flip, color mode(256 or 16)
									//and the palette number if 16 color.  This is only for text backgrounds
									//for rotation backgrounds(wich is what we will be using) screne data is j
									//an 8 bit tile number.  This limits the total tiles to 256 and no 16 color
									//palettes.
u16* CharData2 = (u16*)0x6000000;
u16* ScreenData2 = (u16*)0x600f800;



int mode = 0x1C42; //current video mode.  This is the value that will be placed at 0x4000000;
			//this register controles the mode,obj mapping(1 dimensional or 2),visable 
			//backgrounds ond objects, visable windows, you can cause a blanking period by
			//setting bit 7, and switch between front and back buffers with bit 4.  I used
			//WARDERS gbaregister tool to generate this number.  it enables backgrounds 2 and 3
			//and objects, selects linear object mapping, and selects video mode 2.
//////////LUTs 
fixed COS[360];  //LUTs for sign and cosign
fixed SIN[360];

//Declerations
void Menu(void);
void WaitForVsync(void);		//waits for the screen to finish drawing
void Move(void);			    //nothing 
int Get_Input(void);					//reads PAD 
void Wait(int time);					//waits
void InitializeOAM(void);				//clears OAM
void DrawWorld(void);					//puts the BG data in the right place


/*the next two functions handle the background rotation and are specific to this demo meening
//they eill need to be rewritten for your own needs*/

void bgRotate(int angle,int rotate_x, int rotate_y,int scroll_x,int scroll_y, fixed zoom);
void introbgRotate(int angle,int rotate_x, int rotate_y,int scroll_x,int scroll_y, fixed zoom);
void intro(void);  //this is my intro

void DMA3Call(u32* Src,u32* Dst,u32 Cnt)				//used to load our sprite info into vram			
{
	DMA3SAD = (u32)Src;									//where the data is
	DMA3DAD = (u32)Dst;									//where the data goes
	DMA3CNT = Cnt;									//how much data should be loaded + control
													//info (add 0x84000000 to your count to cause 32 bits 
													//to be transfered at a time imediatly).
}
char rand(void)
{
	static s32 seed = 7;				//this just uses a LUT that I generated with VS6.  There
										//is a much better way.  I think nokturns tut2 uses it.
	char temp;
	if (seed > 32000) seed -= 32000;
	
	temp = rand_tab[seed];
	seed += rand_tab[seed];
	if(!temp)seed++;
	return temp;
}

///////////////// C code entry (main())/////////////////////
int C_entry()
{
	Sprite guy;
	int i;

	InitializeOAM(); //this function intializes all sprite atributes such that they are 
				//not shown on the screen.  OAM is aranged starting at 0x7000000
				//It has four 16 bit atributes per sprite, the first atribute controls
				//the Y coordinate, mosaic enable,color mode(16 or 256 color palette),
				//double size enable(will be explained later),OBJ mode(this is the cool one,
				//once again to explained later),OBJ form(squar rec ect...explained later),
				//and rotation/scale enable...Thats a lot for 16 bits huh?
				//Atribute 2 determins obj size, x coordinate, rotation/scaling peramiter
				//selection,horizontal and vertical flip,
				//Atribute 3 is the character name(ie the tiles it coorisponds to in
				//video mem., priority(what order it is drawn),number of palette if 16 
				//color
				//The last atribute is actualy one of four rotation/scaling permiters
				//they control the change in x and y.  OAM memory can not be updated outside
				//of a blanking period and usualy only during the vblank

//this is were the sign and cosign LUT's are created. stored in a table of 24:8 fixed point
//numbers
	for(i = 0;i<360;i++)
	{
		SIN[i] = (fixed)(sin(RADIAN(i))*((float)(1<<8)));
		COS[i] = (fixed)(cos(RADIAN(i))*((float)(1<<8)));
	}
	intro();
	
	REG_DISPCNT = mode;   //set screen mode(REG_DISPCNT = *0x4000000)
	REG_BG3CNT  = 0x7084;  //this is the main control for the background. bits 0&1 conrol priority.
	REG_BG2CNT  = 0x5F80;	//the higher the number the lower the priority.  Priority determines
							//the order in wich the backgrounds and sprites are drawn. the order
							//is as follows BG3,OBJ3,BG2,OBJ2,BG1,OBJ1,BG0,OBJ0. The next 2 bits
							//(2*3)controll what memory to use for character data. Bits 4&5 are 
							//used and 6 controls mosaic enable. 7 controles color mode(set is 
							//256 color not set is 16 color).bits 8-12 control what memory is 
							//used for screen data and bits 14 and 15 control size of the virtual
							//screen.  00 is 256x256, 01 is 512x256, 10 is 256x512, 11 is 512x512.  
							//this only always true for text backgrounds(those that do not have 
							//scaling and rotation abilitis). in mode 1 bg0 & bg1 are text back-
							//grounds and bg 2 is a scaling/rotating backgroun.
							//mode 0 all 4 are text backgrounds.  mode 2 bg 2&3 are rotation and
							//scaling.  bit 13 controls area overflow in scaling/rotation back
/*	//my background are set up as follows:
	BG 2(the land):  256x256  with area overflow set to 0.  this meens that the background will not tile
			screne data is pointed 0x600F800 and tile data to 0x6000000;
	BG 3(the water):  256x256 with area overflow set to 1, this meens it does tile.  screen data is pointed
			to 0x60080000, and tile data is pointed to 0x6004000;


*/	
	DMA3Call((u32*)palette,(u32*)palette_mem,0x84000080); //copies in my palette
	DMA3Call((u32*)palette,(u32*)&palette_mem[256],0x84000080);
	DMA3Call((u32*)tguy,(u32*)OAMdata,0x84000400);
	DrawWorld();   //this is the function that actualy draws the world.  It places the screen 
					//data corisponding to overworld aray.

/////////////////MAIN LOOP////////////////////	
	S_Initialize(&guy,88,48,SIZE_64x64,0);
	while (1)  
	 {
	
		
		S_Animate(&guy);
		Get_Input();  //gets and processes key presses
	
		WaitForVsync();    //wait for the screen to stop drawing
		DMA3Call((u32*)OAM,(u32*)OAMmem,0x84000100);  //copies my oam data to actual oam.				
		bgRotate((int)angle,x_rotate,y_rotate,x_scroll,y_scroll,zoom);
		
	}//end main loop

}//end C_entry()
//////////////////////////////////////////////

///////WaitForVsync//////////////////////////
void WaitForVsync(void)
{
	__asm 
	{
		mov 	r0, #0x4000006   //0x4000006 is vertical trace counter; when it hits 160					 //160 the vblanc starts
		scanline_wait:	       	//the vertical blank period has begun. done in asm just 
								//because:)
		ldrh	r1, [r0]
		cmp	r1, #160
		bne 	scanline_wait
	}			
}



///////////////Get Input////////////////////////////////
int Get_Input(void)
{
	
//keypad register is a 16 bit register at 0x40000130;
//key bits are reset when a key is pressed.  Keys are defined in
//keypad.h.  Returns 1 if a key is pressed 0 otherwise.
	fMoved = 0;

	if(!((*KEYS) & KEY_UP))        //is UP bit 0?
	{
	
		if(angle < 270)					//scrolls the background acording to the directional
			y_scroll-=SIN[angle+90];	//pad.  Uses a little trig to make sure we scroll just 
		else							//horizontal or vertical even when the screen is rotated
			y_scroll-=SIN[angle-270];	//if i didn't add the trig it would scroll int the direction
										//of the angle(try it and see)
		if(angle < 270)
			x_scroll+=COS[angle+90];
		else
			x_scroll+=COS[angle-270];
		fMoved =1;
	}
	if(!((*KEYS) & KEY_DOWN))    //same for down left and right
	{
		if(angle < 270)
			y_scroll+=SIN[angle+90];
		else
			y_scroll+=SIN[angle-270];
		if(angle < 270)
			x_scroll-=COS[angle+90];
		else
			x_scroll-=COS[angle-270];
		fMoved = 1;
	}
	if(!((*KEYS) & KEY_LEFT))
	{
		x_scroll+=COS[angle];
		y_scroll-=SIN[angle];
		fMoved =1;
	}
	if(!((*KEYS) & KEY_RIGHT))
	{
		x_scroll-=COS[angle];
		y_scroll+=SIN[angle];
				fMoved = 1;
	}
	if(!((*KEYS) & KEY_A))  //a and b zoom
	{
		
		zoom++;
		//do A button stuff here
		fMoved = 1;
	}
	if(!((*KEYS) & KEY_B))
	{
	
		zoom--;
		//do B button stuff here
		fMoved = 1;	
	}
	if(!((*KEYS) & KEY_R))  //r and l rotate
	{
	
		angle++;
		if(angle>359)
			angle = 0;
		//do R button stuff here
		fMoved = 1;	
	}
	if(!((*KEYS) & KEY_L))
	{
	
		angle--;
		if(angle < 0)
			angle = 359;
		//do R button stuff here
		fMoved = 1;
	}
	if(!((*KEYS) & KEY_START))  //start and select change the rotion/zoom center
	{
		Menu();
		x_rotate++;
		fMoved = 1;
	}
	if(!((*KEYS) & KEY_SELECT))
	{
		x_rotate--;
		fMoved = 1;
	}
	return(fMoved);
}

/////////////////////////////////////////////////////////

////////////////////MOVE/////////////////////////////////
void Move(void)
{
	
	//this is were we check temp to see if it is a tile we can walk on.  It probably would be
	//more eficient to have a hole seperate aray for this but this works too;)


}

void Wait(int time)//this is wait funtcion that is exponential in nature(ie proprtional to 
					//time^2)
{
	int i1,i2,temp;
	for(i1 = 0; i1 < time; i1++)
		for(i2 = 0; i2 < time; i2++)
			temp = i1/i2;  //divides are SLOOOOOOOOOOOWWWW
}//end Wait




void InitializeOAM(void)
{
	int i;
	for(i = 0; i<(128 * 4); i+=4)  //all this function does is set atribute 1(y) and 2(x) to 
	{					//to a location not on the screen to prevent them from
		OAM[i] = 241;		//being displayed.
		OAM[i+1] = 241;
	}
}
void DrawWorld(void)
{
	//these just copy the map and tile date to VRAM
	DMA3Call((u32*)textures,(u32*)CharData2,0x84001000);
	DMA3Call((u32*)map,(u32*)ScreenData2,0x84000100);

	DMA3Call((u32*)twater,(u32*)CharData3,0x84000100);
	DMA3Call((u32*)mwater,(u32*)ScreenData3,0x84000100);
}

//////////////////////menu///////
void Menu(void)
{
//no menu yet:(
}

/////////////////////bg rotate///
void bgRotate(int angle,int rotate_x, int rotate_y,int scroll_x,int scroll_y, fixed zoom)
{
	//rotate_x and y are the center of rotation/zoom and scroll is the map scroll (like BGxHOFS
	//and BGxVOFS in the text backgrounds.
	
	static int bg3_scrollx = 0;   //these variables are used to cause a continuose scrolling 
								  //of the water
	static int bg3_scrolly = 0;


	bg3_scrollx += (1<<4) + scroll_x;  //increment the continouse scroll and add to the desired scroll
	bg3_scrolly += (1<<4) + scroll_y;

	
//the rotation center must take the zoom into effect or else you will allways zoom to the 
	//uper left corner of the screen

	rotate_y = ((rotate_y )) * zoom>>8;   
	rotate_x = ((rotate_x )) * zoom>>8;
//these to registers hold the coordinant of the upper left hand coordinant to the screen
//so to get your center of rotation to move you must draw a circle around it based on your 
//rotation angle(that is what all the sin and cos crap is for).  By simply adding a value to 
//to these registers you will change the pixle displayed at the Upper left corner therefor 
//causing the background to scroll.
	REG_BG2X = (((scroll_x))-rotate_y*SIN[angle]-rotate_x*COS[angle]);//*COS[359-angle];//*COS[angle];//*120;
	REG_BG2Y = (((scroll_y))-rotate_y*COS[angle]+rotate_x*SIN[angle]);//*SIN[359-angle];//*SIN[angle];//*80;
	
//these registers hold the change in x and y for a given reference (a rotation matrix if
//that helps)  these registers are all fixed point(that is why all the shifts).  they are 19
//bits integer with 8 bits of fraction;

	REG_BG2PA = (COS[angle]*zoom)>>8;  //cos&sin are LUTs that are .8 fixed numbers
	REG_BG2PB = (SIN[angle]*zoom)>>8; //zoom is also fixes
	REG_BG2PC = (-SIN[angle]*zoom)>>8;
	REG_BG2PD = (COS[angle]*zoom)>>8;


	REG_BG3X = (((bg3_scrollx))-rotate_y*SIN[angle]-rotate_x*COS[angle]);//*COS[359-angle];//*COS[angle];//*120;
	REG_BG3Y = (((bg3_scrolly))-rotate_y*COS[angle]+rotate_x*SIN[angle]);//*SIN[359-angle];//*SIN[angle];//*80;
	
	
	REG_BG3PA = (COS[angle]*zoom)>>8;  //cos&sin are LUTs that are .8 fixed numbers
	REG_BG3PB = (SIN[angle]*zoom)>>8; //zoom is also fixes
	REG_BG3PC = (-SIN[angle]*zoom)>>8;
	REG_BG3PD = (COS[angle]*zoom)>>8;

}

void intro(void)
{
	//this is my intro function wich I tried to make as stand alone as posable so I could use it on
	//the rest of my project.
	
	u16* ScreenData3 = (u16*)0x6008000; //this were the screen map goes.  It can be placed any 
									//ware on a 2k boundry in video ram.  Must be specified
									//by BG*CNT register.  By setting bits 8 - 12 you can specify
									//were screne data resides.  It is just a 5 bit number
									//were 0 = 0x6000000, 1 = 0x6000500 ...16 =0x6008000 ...
									//31 = 0x600f500.
	u16* CharData3 = (u16*)0x6004000;   //this is were the actual tile data goes.  It is controled
									//by bits 2 and 3 of BG*CNT.  tile data can be placed on any 
									//16k boundry in video ram.You must ensure that the BG*CNT
									//register points to the corect memory location for character
									//data and screen data.
	u16* CharData2 = (u16*)0x6000000;
	u16* ScreenData2 = (u16*)0x600f800;

	int fadein = 0x10<<8;
	int i,a; 

	

	REG_DISPCNT = 0x0C42;   //set screen mode(REG_DISPCNT = *0x4000000)
	REG_BG3CNT  = 0x7084;  //this is the main control for the background. bits 0&1 conrol priority.
	REG_BG2CNT  = 0x7F80;

	DMA3Call((u32*)tdov,(u32*)CharData2,0x840003B0);
	DMA3Call((u32*)mdov,(u32*)ScreenData2,0x84000100);

	DMA3Call((u32*)tweb,(u32*)CharData3,0x84000950);
	DMA3Call((u32*)mweb,(u32*)ScreenData3,0x84000100);

	DMA3Call((u32*)pintro,(u32*)palette_mem,0x84000080);


	REG_BG2X = 0;//(-(120+64<<8));
	REG_BG2Y = 0;//(-(80+64<<8));
	
	REG_BG3X = 0;//(-(120+128<<8));
	REG_BG3Y = 0;//(-(80+128<<8));//-rotate_y*COS[angle]+rotate_x*SIN[angle]);//*SIN[359-angle];//*SIN[angle];//*80;
	

	a = 0;
	while(!Get_Input())
	{
		a++;
		if(a > (359))
			a = 0;
		WaitForVsync();
		introbgRotate((a),120,80,128<<8,108<<8,(4<<8));
		
	}
	i = 4<<8;
	while(a>0  ||  i >(1<<8))
	{
		a--;
		if(a<0)
			a = 359;
		if(i > (1<<8))
			i-=2;
		WaitForVsync();
		introbgRotate((a),120,80,128<<8,108<<8,(i));
	}
	
	
	
	//Wait(1000);
	REG_COLEY = 0xF9F;
	REG_BLDMOD = 0x08C;
	while(!Get_Input())
	{
		fadein --;
		if(fadein <0)
			fadein = 0x10 << 10;
		REG_COLEY = fadein >>10;

	}
	while(i>0)
	{
		i--;
		WaitForVsync();
		introbgRotate((a),120,80,128<<8,108<<8,(i));
	}
	
	REG_BLDMOD = 0;

}
void introbgRotate(int angle,int rotate_x, int rotate_y,int scroll_x,int scroll_y, fixed zoom)
{
	
//this is the same as the other rotate function without the continuose scroll of background 3
//it also reverses the angle of rotation for BG 3.
	rotate_y = ((rotate_y )) * zoom>>8;
	rotate_x = ((rotate_x )) * zoom>>8;
	REG_BG2X = (((scroll_x))-rotate_y*SIN[angle]-rotate_x*COS[angle]);//*COS[359-angle];//*COS[angle];//*120;
	REG_BG2Y = (((scroll_y))-rotate_y*COS[angle]+rotate_x*SIN[angle]);//*SIN[359-angle];//*SIN[angle];//*80;
	
	
	REG_BG2PA = (COS[angle]*zoom)>>8;  //cos&sin are LUTs that are .8 fixed numbers
	REG_BG2PB = (SIN[angle]*zoom)>>8; //zoom is also fixes
	REG_BG2PC = (-SIN[angle]*zoom)>>8;
	REG_BG2PD = (COS[angle]*zoom)>>8;

	if(angle)
		angle = 360 - angle;
	REG_BG3X = (((scroll_x))-rotate_y*SIN[angle]-rotate_x*COS[angle]);//*COS[359-angle];//*COS[angle];//*120;
	REG_BG3Y = (((scroll_y))-rotate_y*COS[angle]+rotate_x*SIN[angle]);//*SIN[359-angle];//*SIN[angle];//*80;
	
	
	REG_BG3PA = (COS[angle]*zoom)>>8;  //cos&sin are LUTs that are .8 fixed numbers
	REG_BG3PB = (SIN[angle]*zoom)>>8; //zoom is also fixes
	REG_BG3PC = (-SIN[angle]*zoom)>>8;
	REG_BG3PD = (COS[angle]*zoom)>>8;

}